#include <stdlib.h>
#include <math.h>

/* Some <math.h> files do not define M_PI... */
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define STEP 24

#include <GL/glut.h>
static void
  Key(unsigned char key, int x, int y)
{
  switch (key) {
  case 27:
    exit(0);
  }
}
 
void  display (void)
{
	int i;

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
	
   	for(i=0;i<STEP;i++)
	{
		glLoadIdentity ();  
		glRotatef(i*360.0/STEP,0,1,0); 
		glTranslatef(10,0,0);
		glRotatef(i*180.0/STEP,0,0,1); 
		glScalef(3.0,1.0,1.0);
		glutWireCube(1.0);
	}

	glutSwapBuffers();
}

void  myinit (void) {
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glClearColor (0.0, 0.0, 0.0, 0.0);
    }

/*  Called when the window is first opened and whenever 
 *  the window is reconfigured (moved or resized).
 */
void  reshape(GLsizei w, GLsizei h)
{
	glMatrixMode (GL_PROJECTION);   /*  prepare for and then  */ 
	glLoadIdentity ();  /*  define the projection  */
	gluPerspective(40.0,(float)w/(float)h,10,1000);
	gluLookAt(20,10,30,
		0,0,0,
		0,1,0);
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
}

/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  RGBA display mode, and handle input events.
 */
int main(int argc, char** argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB);
    glutInitWindowSize(400, 400);
    glutInitWindowPosition (10, 10);

    glutCreateWindow (argv[0]);
 	glutDisplayFunc(display);
	glutReshapeFunc(reshape); 
	glutKeyboardFunc(Key);	
	myinit();
	glutMainLoop();
	return(0);
}
