#include <stdlib.h>  // needed for rand() and srand()
#include <math.h>

/* Some <math.h> files do not define M_PI... */
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define STEP 24

#include <GL/glut.h>
static void
  Key(unsigned char key, int x, int y)
{
  switch (key) {
  case 27:
    exit(0);
  }
}
 
GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};  /* White diffuse light. */
GLfloat light_position[] = {1.0, 1.0, 1.0, 0.0};  /* Infinite light location. */
static GLfloat blueMaterial[] = {0.0, 0.2, 1.0, 1.0},
  redMaterial[] = {0.9, 0.2, 0.2, 1.0},
  purpleMaterial[] = {0.3, 0.0, 0.3, 1.0},
  greenMaterial[] = {1.0, 0.2, 0.0, 1.0},
  whiteMaterial[] = {1.0, 1.0, 1.0, 1.0};

void  display (void)
{

	int i;
	static int angle=0;
	angle=(angle+2)%360;

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
	
	srand(1);

	for(i=0;i<STEP;i++)
	{
		glLoadIdentity ();  
		glRotatef(i*360.0/STEP,0,1,0); 
		glTranslatef(10,0,0);
		glRotatef(i*180.0/STEP,0,0,1); // Zeta axis Rotation
		glScalef(3.0,1.0,1.0);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, whiteMaterial);
    	glutSolidCube(1.0);
	}

	glLoadIdentity ();  
	glRotatef(angle*2,0,1,0);
	glTranslatef(10,0,0);
	glRotatef(angle,0,0,1);
	glTranslatef(0,1,0);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, redMaterial);
    glutSolidCube(1.0);

	glutSwapBuffers();
}

void  myinit (void) {
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glClearColor (0.0, 0.0, 0.0, 0.0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);

    }

/*  Called when the window is first opened and whenever 
 *  the window is reconfigured (moved or resized).
 */
void  reshape(GLsizei w, GLsizei h)
{
	glMatrixMode (GL_PROJECTION);   /*  prepare for and then  */ 
	glLoadIdentity ();  /*  define the projection  */
	gluPerspective(40.0,(float)w/(float)h,10,1000);
	gluLookAt(20,20,20,
		0,0,0,
		0,1,0);
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
}

/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  RGBA display mode, and handle input events.
 */
int main(int argc, char** argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB);
    glutInitWindowSize(400, 400);
    glutInitWindowPosition (10, 10);

    glutCreateWindow (argv[0]);
 	glutDisplayFunc(display);
	glutReshapeFunc(reshape); 
	glutIdleFunc(display);
	glutKeyboardFunc(Key);	
	myinit();
	glutMainLoop();
	return(0);
}
